﻿#include "Game.hpp"

Game::Game(sf::RenderWindow& window) : window(window)
{
}

#include <iostream>
void Game::run()
{
#ifdef _DEBUG
	std::cout << "Loading map... Version: " MAP_VERSION_STRING << std::endl;
	const auto start = std::chrono::system_clock::now();
#endif

	auto [message, code] = map.load(ASSETS_PATH "/test.cymf");

#ifdef _DEBUG
	const auto end = std::chrono::system_clock::now();
	const auto milliseconds = std::chrono::duration_cast<std::chrono::microseconds>(end - start);
	std::cout << "Loading took: " << milliseconds << std::endl;
#endif

	map.setPosition(sf::Vector2f{20, 20});

	if (code != 0)
	{
		std::cout << message << std::endl;
		return;
	}
#ifdef _DEBUG
	map.debug();
#endif
	while (window.isOpen())
	{
		while (const auto event = window.pollEvent())
		{
			if (event->is<sf::Event::Closed>())
			{
				window.close();
			}
		}


		// Render game
		window.clear({0x20, 0x20, 0x20,0xff});

		window.draw(map);

		window.display();
	}
}
